/* aviary.cpp simulates sitting in an aviary.
 * 
 * Copyright Joel Adams 2001, all rights reserved
 */
 
#include "Chicken.h"
#include "Duck.h"
#include "GreenParrot.h"
#include "Hawk.h"
#include "Jabberwock.h"
#include "Peacock.h"
#include "RedParrot.h"
#include "RandomInt.h"
#include <iostream>
#include <vector>
using namespace std;

int main()
{
  const int NUMBER_OF_BIRDS = 7;
  
  vector<Bird*> birdVec(NUMBER_OF_BIRDS);        // sequence of birds
  
  birdVec[0] = new Chicken();                    // allocate birds dynamically
  birdVec[1] = new Duck();
  birdVec[2] = new GreenParrot();
  birdVec[3] = new Hawk();
  birdVec[4] = new Jabberwock(); 
  birdVec[5] = new Peacock();
  birdVec[6] = new RedParrot();
  
  cout << "\nWelcome to the Bird Aviary!\n"      // enter the simulation
       << "\nTo remain in the aviary, keep pressing 'Enter';\n"
       << " enter any other character to leave:\n\n";
  int i;
  Bird* aBird;
  char response;
  RandomInt d7(0, NUMBER_OF_BIRDS-1);
  for (;;)                                       // simulation event loop
  {
    cin.get(response);                           // see if user wants to continue
    
    if (response != '\n') break;
    
    i = d7.generate();                           // generate a 'random' index
    aBird = birdVec[i];                          // initialize handle
    cout << "A " << aBird->getKind()             // describe our 'random' bird
         << " just " << aBird->getMovement()
         << " by, calling \"" << aBird->getCall()
         << "\"...\n" << endl;
  }
  
  for (i = 0; i < NUMBER_OF_BIRDS; i++)          // deallocate birds
    delete birdVec[i];
  
  cout << "\nGood-bye, and come again!" << endl; // fair well
}
 